% Calculates standard deviations for each metric from the training data set

% Load normal-behavior data file
%DATA = load('normal-behavior-newcapacity-20100125');
%DATA = load('android/android_normal_parsed');
DATA = load('android_v3/normal_diff.dat');
%DATA = load('itap/itap_normal_traces_after_a_day_of_failure.dat');

% Number of workloads in the data file
%numberWorkloads = 3;
numberWorkloads = 1; % android

% Size of workloads
sizeOfData = size(DATA);

% Number of metrics
%numMetrics = 143;
numMetrics = 10; % android
%numMetrics = 151; % Itap

% Size of workload
sizeOfWorkload = sizeOfData(2)/numMetrics; % for non-itap data only
%sizeOfWorkload = sizeOfData(1); % for itap only

% STDs vector
workloadSTD = zeros(numberWorkloads, numMetrics);

for i=1:numberWorkloads,
   workload = zeros(sizeOfWorkload, numMetrics);
   
   % Transform data set
   for j=1:numMetrics,
      for k=1:sizeOfWorkload
          workload(k,j) = DATA(i, (j-1)*sizeOfWorkload + k);
      end
   end
   
   workload = filter_data(workload);
   
   workloadSTD(i,:) = std(workload);
end

STD = mean(workloadSTD);
save('STD.dat','STD','-ascii', '-double', '-tabs');