function [ RHO ] = kl_divergence( data )
%KL_DIVERGENCE Summary of this function goes here
% data: columns=metrics, rows=observations
% std: standard deviation per metric

sizeOfData = size(data);

% number of metrics
numMetrics = sizeOfData(2);

% RHO matrix
RHO = zeros(numMetrics,numMetrics) + 1;

for i=1:numMetrics-1,
   for j=i+1:numMetrics,
       x = data(:,i);
       y = data(:,j);
       
       % Get means
       mean_x = mean(x);
       mean_y = mean(y);
       
       % Get stds
       std_x = std(x) / abs(mean_x);
       std_y = std(y) / abs(mean_y);
       
       %std_x = std_x^2.0;
       %std_y = std_y^2.0;
       
       % Check if stds are zero
       %if (std_x == 0),
       %   std_x = 1e-6; 
       %end
       
       %if (std_y == 0),
       %   std_y = 1e-6; 
       %end
       
       if (std_x == 0 || std_y == 0),
           div = 0;
       else
           % Get symmetric KL-divergence (Jensen–Shannon divergence)
           %div_1 = 0.5 * (std_x/std_y - 1 - log(std_x/std_y));
           %div_2 = 0.5 * (std_y/std_x - 1 - log(std_y/std_x));
           %div = 0.5 * div_1 + 0.5 * div_2;
           
           %div = abs(log(div));
           
           if (std_x > std_y)
               div = std_y / std_x;
           else
               div = std_x / std_y;
           end
           div = abs(log(div));
           
       end
       
       % Save coefficient
       RHO(i,j) = div;
       RHO(j,i) = div;
   end
end

end

