function [RHO] = pearson_corr(data, STD)
% data: columns=metrics, rows=observations
% std: standard deviation per metric

sizeOfData = size(data);

% number of metrics
numMetrics = sizeOfData(2);

% number of pair-wise coefficients
%numCoeff = numMetrics*(numMetrics-1)/2;

% RHO matrix
RHO = zeros(numMetrics,numMetrics) + 1;

for i=1:numMetrics-1,
   for j=i+1:numMetrics,
       x = data(:,i);
       y = data(:,j);
       
       mean_x = mean(x);
       mean_y = mean(y);
       
       x = x - mean_x;
       y = y - mean_y;
       
       std_score_x = x/STD(i);
       std_score_y = y/STD(j);
       
       % Pearson corr-coefficient
       coeff = dot(std_score_x,std_score_y);
       coeff = coeff / (sizeOfData(1)-1);
       
       % Calculate correlation coefficient
       %coeff = num./(STD(i)*STD(j));
       
       % Save coefficient
       RHO(i,j) = coeff;
       RHO(j,i) = coeff;
   end
end

end

