/*
 * data_loading.h
 *
 *  Created on: Feb 9, 2011
 *      Author: Ignacio Laguna
 *     Contact: ilaguna@purdue.edu
 */

#ifndef DATA_LOADING_H_
#define DATA_LOADING_H_

#include "detection_engine.h"

using namespace std;

/* Load metric names from a file */
void load_metric_names();

/* Load vectors with constant metrics (or dimensions) and values. */
void load_const_dims_vector();

/* Load valid CCV dimensions. */
void loadValidCCVDimensions();

/* Load the normal-behavior CCVs into a hyper-sphere structure */
void load_ccvs();

/* This function loads ARIMA models into the modelsBase structure. */
void load_models();

/* Load standard deviations calculated from the training phase */
void load_standard_deviations();

#endif /* DATA_LOADING_H_ */
