/*
 * nearest_neighbor.h
 *
 *  Created on: Feb 9, 2011
 *      Author: Ignacio Laguna
 *     Contact: ilaguna@purdue.edu
 */

#ifndef NEAREST_NEIGHBOR_H_
#define NEAREST_NEIGHBOR_H_

#include <vector>
#include <map>

using namespace std;
/*
 * Checks whether we are interested in a dimension in the CCV.
 * A dimension in the CCV is wanted if any of the two metrics
 * (in the pair-wise correlation coefficient) is in the desired metrics
 * vector.
 */
bool isCCVDimensionWanted(unsigned int dim,
		const vector<unsigned int> &desiredMetrics);

/* Euclidean distance */
double euclidean_dist(const vector<double> &x, const vector<double> &y);

/* Calculate distance of CCV from hyper-sphere using KNN. */
double knn_ccv_distance(const vector <double> &ccv,
		const vector< vector<double> > &sphere);

//void calculate_knn_threshold();

void calculate_knn_thresh();

#endif /* NEAREST_NEIGHBOR_H_ */
