/*
 * set_config.C
 *
 *  Created on: Feb 7, 2011
 *      Author: Ignacio Laguna
 *     Contact: ilaguna@purdue.edu
 */

#include "set_config.h"
#include "global.h"
#include "detection_engine.h"
#include "utilities.h"

#include <stdlib.h>

void set_config_parameters() {
	char *var;

	/* Get window size */
	if ((var = getenv("ERROR_DETECT_WIN_SIZE")) != NULL)
		config.win_size = static_cast<unsigned int>(atoi(var));
	else
		handle_error("Error in set_global_variables(): "
				"could not find ERROR_DETECT_WIN_SIZE");

	/* Get predictions size */
	if ((var = getenv("ERROR_DETECT_PRED_SIZE")) != NULL)
		config.predict_size = static_cast<unsigned int>(atoi(var));
	else
		handle_error("Error in set_global_variables(): "
				"could not find ERROR_DETECT_PRED_SIZE");

	/* Get whether or not to use predictions */
	if ((var = getenv("ERROR_DETECT_USE_PREDICTIONS")) != NULL) {
		unsigned int value = static_cast<unsigned int>(atoi(var));
		if (value == 1) config.use_predictions = true;
		else config.use_predictions = false;
	} else
		handle_error("Error in set_global_variables(): could not find "
				"ERROR_DETECT_USE_PREDICTIONS");

	/* Get number of metrics */
	if ((var = getenv("ERROR_DETECT_NUM_METRICS")) != NULL)
		config.num_metrics = static_cast<unsigned int>(atoi(var));
	else
		handle_error("Error in set_global_variables(): could not find "
				"ERROR_DETECT_NUM_METRICS");
}
