/*
 * utilities.C
 *
 *  Created on: Feb 7, 2011
 *      Author: Ignacio Laguna
 *     Contact: ilaguna@purdue.edu
 */

#include "utilities.h"
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string>

using namespace std;

void handle_error(const char *message)
{
	cerr << string("[detection_engine]: ") + message << endl;
	cerr.flush();
	exit(EXIT_FAILURE);
}

void print_vector(const vector<double> &vec, const char *filename)
{
	FILE *fd;
	fd = fopen(filename, "w");
	for (size_t i=0; i < vec.size(); i++) {
		char c[50];
		c[0] = '\0';
		if (i == (vec.size() - 1)) {
			sprintf(c, "%f\n",vec[i]);
		} else {
			sprintf(c, "%f,",vec[i]);
		}
		fputs(c, fd);
	}
	fclose(fd);
}

void Tokenize(const string& str, vector<string>& tokens,
		const string& delimiters = " ")
{
    // Skip delimiters at beginning.
    string::size_type lastPos = str.find_first_not_of(delimiters, 0);
    // Find first "non-delimiter".
    string::size_type pos     = str.find_first_of(delimiters, lastPos);

    while (string::npos != pos || string::npos != lastPos)
    {
        // Found a token, add it to the vector.
        tokens.push_back(str.substr(lastPos, pos - lastPos));
        // Skip delimiters.  Note the "not_of"
        lastPos = str.find_first_not_of(delimiters, pos);
        // Find next "non-delimiter"
        pos = str.find_first_of(delimiters, lastPos);
    }
}
