/*
 * utilities.h
 *
 *  Created on: Feb 7, 2011
 *      Author: Ignacio Laguna
 *     Contact: ilaguna@purdue.edu
 */

#ifndef UTILITIES_H_
#define UTILITIES_H_

#include <iostream>
#include <vector>
#include <string>

using namespace std;

#define ASSERT_TRUE(condition, message) { \
	if ( !(condition) ) { \
		std::cout << "\t Assertion failed: " << std::string(message) << "\n"; \
		std::cout << " on line " << __LINE__  << "\n"; \
		std::cout << " in file " << __FILE__ << "\n";  \
		std::cout.flush(); \
		exit(EXIT_FAILURE); \
    } \
	else { \
    	std::cout << "\tTRUE: " << std::string(message) << "\n"; \
	} \
}

/* Print log and exit */
void handle_error(const char *message);

/* Print vector into a file */
void print_vector(const vector<double> &vec, const char *filename);

/* Tokenize string */
void Tokenize(const string& str, vector<string>& tokens,
		const string& delimiters);


#endif /* UTILITIES_H_ */
